﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class AlternateActive : MonoBehaviour {

	public GameObject[] images;
	public float alternationInterval = 1f;

	int activeIndex = 0;

	IEnumerator Start() {
		while( enabled ) {
			for( int index = 0; index < images.Length; index++ ) {
				images[index].gameObject.SetActive( false );
			}

			images[activeIndex].gameObject.SetActive( true );

			activeIndex = (activeIndex + 1) % images.Length;

			yield return new WaitForSeconds( alternationInterval );
		}
	}
}
