﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class BackgroundLineRenderer : MonoBehaviour {

    public LineRenderer lineRendererBackground;
    public QueueWave queue;
    public Tapping inputController;
    public float saturation = 1f;

    private Gradient g;
    private float alpha = 1f;
    private Color top;
    private Color bottom;

    // Use this for initialization
    void Start () {

        g = new Gradient();
        g.SetKeys(
        new GradientColorKey[] { new GradientColorKey(GetColor.getColorFromHSV(0f, 1f), 0.0f), new GradientColorKey(GetColor.getColorFromHSV(0f, 1f), 1.0f),
                                    new GradientColorKey(GetColor.getColorFromHSV(0f, 1f), 0.0f), new GradientColorKey(GetColor.getColorFromHSV(0f, 1f), 1.0f),
                                    new GradientColorKey(GetColor.getColorFromHSV(0f, 1f), 0.0f), new GradientColorKey(GetColor.getColorFromHSV(0f, 1f), 1.0f),
                                    new GradientColorKey(GetColor.getColorFromHSV(0f, 1f), 0.0f), new GradientColorKey(GetColor.getColorFromHSV(0f, 1f), 1.0f)},
        new GradientAlphaKey[] { new GradientAlphaKey(alpha, 0.0f), new GradientAlphaKey(alpha, 0.0f),
                                    new GradientAlphaKey(alpha, 0.0f), new GradientAlphaKey(alpha, 0.0f),
                                    new GradientAlphaKey(alpha, 1.0f), new GradientAlphaKey(alpha, 1.0f),
                                    new GradientAlphaKey(alpha, 1.0f), new GradientAlphaKey(alpha, 1.0f)}
    );
        lineRendererBackground.colorGradient = g;

    }
	
	// Update is called once per frame
	void Update () {

        g = new Gradient();

        bottom = GetColor.getColorFromHSV(Mathf.Clamp((1 - inputController.currentInterval) * GetColor.multiplier, GetColor.minClamp, GetColor.maxClamp), saturation);
        top = GetColor.getColorFromHSV(Mathf.Clamp((1 - queue.playerGoal) * GetColor.multiplier, GetColor.minClamp, GetColor.maxClamp), saturation);

        g.SetKeys(
                    new GradientColorKey[] { new GradientColorKey(top, 0.0f), new GradientColorKey(top, 1.0f),
                                                    new GradientColorKey(top, 0.0f), new GradientColorKey(top, 1.0f),
                                                    new GradientColorKey(bottom, 0.0f), new GradientColorKey(bottom, 1.0f),
                                                    new GradientColorKey(bottom, 0.0f), new GradientColorKey(bottom, 1.0f)},
                    new GradientAlphaKey[] { new GradientAlphaKey(alpha, 0.0f), new GradientAlphaKey(alpha, 0.0f),
                                                    new GradientAlphaKey(alpha, 0.0f), new GradientAlphaKey(alpha, 0.0f),
                                                    new GradientAlphaKey(alpha, 1.0f), new GradientAlphaKey(alpha, 1.0f),
                                                    new GradientAlphaKey(alpha, 1.0f), new GradientAlphaKey(alpha, 1.0f)}
                );
        lineRendererBackground.colorGradient = g;
    }

    public void scoreChange(float saturation)
    {
        this.saturation = saturation;
    }
}
