﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

using System;

public class Fade : MonoBehaviour {

	public Image fadeImage;

	public bool fadeOnStart = false;

	void Start() {
		if( fadeOnStart ) {
			Out();
		}
	}

	public void Out( float speed = 1f, Action callback = null ) {
		StartCoroutine( FadeTo( 0f, speed, callback ) );
	}

	public void In( float speed = 1f, Action callback = null ) {
		StartCoroutine( FadeTo( 1f, speed, callback ) );
	}

	IEnumerator FadeTo( float target, float speed, Action callback ) {
		Color origColor = fadeImage.color;
		float time = 0f;
		
		while( fadeImage.color.a != target ) {
			Color imageCol = fadeImage.color;
			imageCol.a = Mathf.Lerp( origColor.a, target, time );
			fadeImage.color = imageCol;

			time += Time.deltaTime * speed;

			yield return null;
		}

		if( callback != null ) callback();
	}
}
