﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Game : MonoBehaviour {

	public Fade backFade;
	public ScoreLabel scoreLabel;
	public RectTransform splatParent;
	public Splat[] splatPrefabs;
	public float splatInterval = 0.1f;

	public void Over( float finalScore ) {
		StartCoroutine( Splats( finalScore ) );
	}

	IEnumerator Splats( float finalScore ) {
		int numSplats = Mathf.Clamp( (int)finalScore, 1, 100 );
		for( int index = 0; index < numSplats; index++ ) {
			Splat splat = Instantiate<Splat>( splatPrefabs[ Random.Range(0, splatPrefabs.Length) ] );
			splat.transform.SetParent( splatParent, false );

			Vector2 randomAnchoredPos = new Vector2( Random.Range( -splatParent.rect.width / 2f, splatParent.rect.width / 2f ), Random.Range( -splatParent.rect.height / 2f, splatParent.rect.height / 2f ) );

			splat.rectT.anchoredPosition = randomAnchoredPos;
			splat.rectT.eulerAngles = new Vector3( 0f, 0f, Random.Range( 0f, 360f ) );
			splat.image.color = new Color( 
				Random.Range( 0f, 1f ),
				Random.Range( 0f, 1f ),
				Random.Range( 0f, 1f ),
				1f
			);

			yield return new WaitForSeconds( splatInterval );
		}

		backFade.gameObject.SetActive( true );
		backFade.In( 1f, () => DisplayScore( (int)finalScore ) );
	}

	void DisplayScore( float finalScore ) {
		scoreLabel.gameObject.SetActive( true );
		scoreLabel.label.text = ((int)finalScore).ToString();
	}
}
