﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Queue : MonoBehaviour {

	const float speedScale = 0.1f;

	public float minChangeGoalRate = 1f;
	public float maxChangeGoalRate = 10f;

	public float minChangeGoalSpeed = 0.1f;
	public float maxChangeGoalSpeed = 2f;

	public float minGoal = 0.1f;
	public float maxGoal = 1f;

	float changeGoalRate = 5f;

	public float currentGoal = 1f;
	float targetGoal = 1f;
	float goalT;
	float interpSpeed;

	void Start() {
		StartCoroutine( ChangeGoals() );
	}

	IEnumerator ChangeGoals() {
		while( enabled ) {

			ChangeGoal( Random.Range( minGoal, maxGoal ), Random.Range( minChangeGoalSpeed, maxChangeGoalSpeed ) );

			yield return new WaitForSeconds( changeGoalRate );
			changeGoalRate = Random.Range( minChangeGoalRate, maxChangeGoalRate );
		}
	}

	public void ChangeGoal( float newGoal, float speed ) {
		targetGoal = newGoal;
		interpSpeed = speed * speedScale;
		goalT = 0f;
	}

	void Update() {
		if( currentGoal != targetGoal ) {
			goalT = Mathf.Clamp( goalT + Time.deltaTime * interpSpeed, 0f, 1f );
			currentGoal = Mathf.Lerp( currentGoal, targetGoal, goalT );
		}
	}

}
