﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

using UnityEngine.SceneManagement;

public class ScoreLabel : MonoBehaviour {

	public string titleScreenName = "Title Screen";

	public float fadeSpeed = 1f;
	public float rainbowSpeed = 0.1f;

	public Text label;
	public CanvasGroup opacity;
	public Fade fade;

	void Start() {
		StartCoroutine( ScaleIn() );
		StartCoroutine( FadeIn() );
		StartCoroutine( Rainbow() );
	}

	IEnumerator ScaleIn() {
		float t = 0f;

		while( transform.localScale.x < 1f ) {
			float newScale = Mathf.Lerp( 0.1f, 1f, t );

			transform.localScale = new Vector3( newScale, newScale, newScale );
			t += Time.deltaTime * fadeSpeed;

			yield return null;
		}
	}
	
	IEnumerator FadeIn() {
		float t = 0f;

		while( opacity.alpha != 1f ) {
			opacity.alpha = Mathf.Lerp( 0f, 1f, t );
			t += Time.deltaTime * fadeSpeed;

			yield return null;
		}
	}

	IEnumerator Rainbow() {
		float t = 0f;
		while( enabled ) {
			label.color = GetColor.getColorFromHSV( t );

			t = (t + Time.deltaTime * rainbowSpeed) % 1f;

			yield return null;
		}
	}

	public void Clicked() {
		fade.gameObject.SetActive( true );
		fade.In( fadeSpeed, () => SceneManager.LoadScene( titleScreenName ) );
	}
}
