﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class Scoreboard : MonoBehaviour {

    public Tapping inputController;
    public QueueWave queue;
    public Game game;
    public int startScore = 100;
    public float buffer = 0.1f;
    public float checkTime = 1f;
    public float minusScore = 1f;
    public float addScore = 1f;
    public ScoreEvent scoreEvent;

    public List<float> saturationList;
    public float gameTimeLength = 60f; //game length in seconds
    public float playedTime = 0; //how long the player has played
    public AudioSource sound;

    private float playerInput;
    private float accumulatedTime;
    private float currentScore;
    private float finalScore;
    private bool gameOver = false;

    // Use this for initialization
    void Start () {
        currentScore = startScore;
        scoreEvent.Invoke(currentScore / 100f);
        //Debug.Log(sound.clip.length);
        gameTimeLength = sound.clip.length;
    }
	
	// Update is called once per frame
	void Update () {
        accumulatedTime += Time.deltaTime;
        playedTime += Time.deltaTime;

        //get player current input value
        playerInput = (1 - inputController.currentInterval) * GetColor.multiplier;
        if (accumulatedTime > checkTime)
        {

            //if within range add to score else remove from score
            if (queue.playerGoal - buffer < playerInput && playerInput < queue.playerGoal + buffer)
            {
                currentScore += addScore;
                scoreEvent.Invoke(currentScore/100f);
                saturationList.Add(currentScore);
            }
            else
            {
                currentScore = currentScore - minusScore;
                scoreEvent.Invoke(currentScore/100f);
                saturationList.Add(currentScore);
            }

            //reset accumulator
            accumulatedTime = 0f;
        }

        //gameover
        if(currentScore < 1 || playedTime > gameTimeLength)
        {
            if(!gameOver)
            {
                gameOver = true;
                foreach (float score in saturationList) { finalScore += score; }
                Debug.Log("finalScore before averaging: " + finalScore);
                Debug.Log("SaturationList Count: " + saturationList.Count);
                
                finalScore = (finalScore / saturationList.Count) * playedTime;
                Debug.Log("Final score: " + finalScore);
                sound.Stop();
                game.Over(finalScore);
            }

        }

	}

    public float getCurrentScore() { return currentScore; }


}
