﻿using System.Collections;
using System.Collections.Generic;
using System;
using UnityEngine;

[RequireComponent(typeof(AudioSource))]
public class SoundPitch : MonoBehaviour {

    public new AudioSource audio;
    public QueueWave queue;
    public Tapping inputController;
    public float checkTime = 1f;
    public float buffer = 0.1f;
    public List<AudioClip> audioTracks;

    private float accumulatedTime;
    private System.Random rnd;

    // Use this for initialization
    void Awake () {
        rnd = new System.Random();
        audio.clip = audioTracks[rnd.Next(audioTracks.Count)];
        audio.Play();
	}
	
	// Update is called once per frame
	void Update () {

        accumulatedTime += Time.deltaTime;

        if (accumulatedTime > checkTime)
        {
            //Debug.Log((1 - queue.playerGoal) - (1 - inputController.currentInterval));
            if ((1 - queue.playerGoal) - (1 - inputController.currentInterval) < buffer)
            {
                audio.pitch = 1f;
            }
            else
            {
                float newPitch = (1 - queue.playerGoal) - (1 - inputController.currentInterval);
                //if the playerGoal is a higher frequncy turn the pitch up, else turn it down
                if (queue.playerGoal > 0.4)
                {
                    audio.pitch = (1 - (1 - queue.playerGoal) - (1 - inputController.currentInterval));
                } else
                {
                    audio.pitch = (1 + (1 - queue.playerGoal) - (1 - inputController.currentInterval));
                }

            }

            //reset accumulator
            accumulatedTime = 0f;
        }


    }
}
