﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class Splat : MonoBehaviour {

	public float maxSize = 2f;

	public float minSpeed = 0.1f;
	public float maxSpeed = 0.5f;

	public RectTransform rectT;
	public Image image;

	IEnumerator Start() {
		float targetScale = Random.Range( 1f, maxSize );
		float randomSpeed = Random.Range( minSpeed, maxSpeed );
		float t = 0f;

		while( transform.localScale.x != targetScale ) {

			float lerpToScale = Mathf.Lerp( transform.localScale.x, targetScale, t );
			transform.localScale = new Vector3( lerpToScale, lerpToScale, lerpToScale );

			t += Time.deltaTime * randomSpeed;

			yield return null;
		}
	}
}
