﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

using UnityEngine.SceneManagement;

public class TitleInput : MonoBehaviour {

	public string sceneToLoad;
	public float lockInputDuration = 1f;

	public Fade fade;
	bool fading = false;

	float timer = 0f;

	void Update() {
		timer += Time.deltaTime;
		if( timer < lockInputDuration ) return;

		if( Input.GetKeyDown( KeyCode.Space ) ) {
			Clicked();
		}
	}

	public void Clicked() {
		if( fading ) return;

		fading = true;
		fade.In( 1f, () => SceneManager.LoadScene( sceneToLoad ) );

		StartCoroutine( Unlock() );
	}

	IEnumerator Unlock() {
		yield return new WaitForSeconds( 1f );
		fading = false;
	}
}
