﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Events;

public class Tapping : MonoBehaviour {

	public const float minInterval = 0f;
	public const float maxInterval = 1f;

	public float smoothing = 1f;
	float smoothFactor { get { return smoothing > 0f ? (1f / smoothing) : 0f; }}

	public float currentInterval = 0f;

	float targetInterval { get { return Mathf.Clamp( _targetInterval, minInterval, maxInterval ); } }
    // Default to nonzero. We can't tap at zero anyway.
    float _targetInterval = 1f; //old value: 0.04f; //Changed to 1f so that it starts out as red

	float[] tapTimes = new float[2];
	bool firstTap = true;

	float timer = 0f;

	void Update() {
		timer += Time.deltaTime;

        if (Input.GetKeyDown(KeyCode.Space))
        {
            Tapped(Time.time);
            timer = 0f;
        }
        Debug.Log("currentInterval: " + currentInterval + ", targetInterval: " + targetInterval);
		currentInterval = Mathf.Lerp( currentInterval, targetInterval, Time.deltaTime * smoothFactor );

		if( timer > maxInterval ) {
			_targetInterval = 1f;
			tapTimes[0] = 1f;
		}
	}

	void Tapped( float tapTime ) {
		if( firstTap ) {
			tapTimes[0] = tapTime;
			firstTap = false;
			return;
		}

		tapTimes[1] = tapTimes[0];
		tapTimes[0] = tapTime;

		_targetInterval = tapTimes[0] - tapTimes[1];

		if( currentInterval == 0f ) currentInterval = targetInterval;
	}
}
